import { useState } from 'react';
import { useController } from './useController';
import { useListener } from './useListener';
function useBuilder(context, buildWhen) {
    var controller = useController(context);
    var _a = useState(controller.state), state = _a[0], setState = _a[1];
    useListener(context, function (newState) { return setState(newState); }, function (prev, curr) { var _a; return (_a = buildWhen === null || buildWhen === void 0 ? void 0 : buildWhen(prev, curr)) !== null && _a !== void 0 ? _a : true; });
    return [state, controller];
}
export { useBuilder };
//# sourceMappingURL=useBuilder.js.map